package sos.stresstest.dialogtest;

import sos.stresstest.dialogtest.DialogTesterBasic;
import sos.connection.SOSConnection;
import sos.util.SOSLogger;

/**
 * Basisklasse fr die Checker-Klassen eines DialogTests.<br>
 * Ein Objekt einer Klasse, die diese Klasse erweitert, wird
 * mittels Reflection in SOSDialogTest erzeugt.
 * 
 * @author fs
 * @since 18.03.2005
 */
public class SOSChecker extends DialogTesterBasic {
	
	/**
	 * Setzt eine Connection.<br>
	 * Wird von SOSDialogTest per Reflection aufgerufen.
	 * @param connection
	 */
	public final void setConnection(SOSConnection connection) {
		
		this.conn = connection;
	}
	
	/**
	 * Setzt einen Logger.<br>
	 * Wird von DialogTester per Reflection aufgerufen.
	 * @param logger
	 */
	public final void setSosLogger(SOSLogger logger) {
		
		this.sosLogger = logger;
	}
	
	
	/**
	 * Diese Methode kann implementiert werden, wenn HTML-Suchstrings fr DialogTester.checkHtml<br>
	 * und DialogTester.checkHtmlAbsent innerhalb der Checker-Klasse definert werden sollen.<br>
	 * Wird von SOSDialogTest erst nach dem evtl. Aufbau einer Connection aufgerufen.<br>
	 * Dadurch knnen HTML-Strings in Abhngigkeit von der Datenbank entstehen.
	 */
	public void initialize(DialogTester dt) throws Exception {
	}
}
