// $Id: spooler_dtd.cxx 4096 2006-02-14 10:50:22Z jz $
/*
    Hier ist implementiert

    Command_processor
*/


#include "spooler.h"


namespace sos {
namespace spooler {

using namespace std;

//-------------------------------------------------------------------------------------------------

const char dtd_string[] = 

"<?xml version='1.0' encoding='iso-8859-1'?>\n"
"<!-- $Id: spooler_dtd.cxx 4096 2006-02-14 10:50:22Z jz $ -->\n"
"\n"
"\n"
"<!ENTITY % command              ' add_jobs\n" 
"                                | add_order\n"
"                                | kill_task \n"
"                                | modify_job \n"
"                                | modify_order\n"
"                                | modify_spooler \n"
"                                | register_remote_scheduler \n"
"                                | remove_job_chain\n"
"                                | remove_order\n"
"                                | run_time \n"
"                                | show_history \n"
"                                | show_job\n"
"                                | show_jobs\n"
"                                | show_job_chains\n"
"                                | show_job_chain\n"
"                                | show_order\n"
"                                | s\n"
"                                | show_state\n"
"                                | show_task\n"
"                                | service_request \n"
"                                | start_job \n"
"                                | signal_object\n"
"                                | terminate          '>\n"
"\n"

"<!ELEMENT spooler               ( config+ | command | answer | %command; )>\n"
"\n"
"\n"
"\n"
"<!-- KONFIGURATION DES SPOOLERS - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -->\n"
"\n"
"<!ELEMENT config              ( base*, security?, process_classes?, script?, object_set_classes?, web_services?, ( holidays | holiday*), jobs?, job_chains? )>\n"
"<!ATTLIST config                spooler_id          CDATA ''>           <!-- Diese Konfiguration ist nur fr einen Spooler mit dieser Kennung -->\n"
"<!ATTLIST config                port                CDATA #IMPLIED>\n"
"<!ATTLIST config                tcp_port            CDATA #IMPLIED>     <!-- Fr TCP-Kommandoschnittstelle -->\n"
"<!ATTLIST config                udp_port            CDATA #IMPLIED>     <!-- Fr UDP-Kommandoschnittstelle -->\n"
"<!ATTLIST config                param               CDATA #IMPLIED>     <!-- Wird der Eigenschaft spooler.param jedem Skript bergeben -->\n"
"<!ATTLIST config                log_dir             CDATA #IMPLIED>\n"
"<!ATTLIST config                priority_max        CDATA #IMPLIED>     <!-- Hchste Prioritt. Gibt absoluten Vorrang -->\n"
"<!ATTLIST config                include_path        CDATA #IMPLIED>     <!-- Pfad fr <include> -->\n"
"<!ATTLIST config                java_class_path     CDATA #IMPLIED>     <!-- Fr Java -->\n"
"<!ATTLIST config                java_options        CDATA #IMPLIED>     <!-- Fr Java -->\n"
"<!ATTLIST config                main_scheduler      CDATA #IMPLIED>     <!-- host:4444 -->\n"
"<!ATTLIST config                mail_xslt_stylesheet CDATA #IMPLIED>\n"
"\n"
"<!ELEMENT base                  EMPTY>\n"
"<!ATTLIST base                  file                CDATA #REQUIRED>\n"
"\n"
"<!ELEMENT security              ( allowed_host* )>\n"
"<!ATTLIST security              ignore_unknown_hosts (yes|no) #IMPLIED> <!-- Unbekannte Hostnamen bei <allowed_host> ignorieren? -->\n"
"\n"
"<!ELEMENT allowed_host          EMPTY>\n"
"<!ATTLIST allowed_host          host                CDATA #REQUIRED>\n"
"<!ATTLIST allowed_host          level               (none|signal|info|no_add|all) #REQUIRED>\n"
"                                                                        <!-- level='none'     Nichts zugelassen (das ist default) -->\n"
"                                                                        <!-- level='signal'   <signal-object> zugelassen, nur UDP -->\n"
"                                                                        <!-- level='info'     <show_state> zugelassen -->\n"
"                                                                        <!-- level='all'      Alles zugelassen -->\n"
"\n"
"<!ELEMENT process_classes       ( process_class* )>\n"
"<!ATTLIST process_classes       ignore              CDATA #IMPLIED>\n"
"\n"
"<!ELEMENT process_class         EMPTY>\n"
"<!ATTLIST process_class         name                CDATA #IMPLIED>\n"
"<!ATTLIST process_class         max_processes       CDATA #IMPLIED>\n"
"\n"
"\n"
"<!ELEMENT object_set_classes    ( object_set_class+ )>\n"
"\n"
"<!ELEMENT object_set_class      ( level_decls?, script? )>\n"
"<!ATTLIST object_set_class      name                CDATA #REQUIRED>\n"
"<!ATTLIST object_set_class      script_interface    (oo|procedural) #IMPLIED> <!-- Objektorientierte oder prozedurale Schnittstelle -->\n"
"\n"
"<!ELEMENT level_decls           ( level_decl+ )>\n"
"\n"
"<!ELEMENT level_decl            EMPTY>\n"
"<!ATTLIST level_decl            level               CDATA #REQUIRED>    <!-- Stufennummer, in der Objektemengeklasse eindeutig -->\n"
"<!ATTLIST level_decl            name                CDATA #REQUIRED>    <!-- Name der Stufe, in der Objektemengeklasse eindeutig -->\n"
"\n"
"\n"
"<!ELEMENT script                ( #PCDATA | include )*>\n"
"<!ATTLIST script                language            CDATA #IMPLIED>     <!-- Z.B. 'VBScript', 'JavaScript', 'PerlScript' -->\n"
"<!ATTLIST script                use_engine          (task) #IMPLIED>    <!-- use_engine='task'  : Jeder Task eine Scripting Engine -->\n"
"                                                                        <!-- use_engine='job'   : Allen Tasks dieses Jobs eine Scripting Engine -->\n"
"<!ATTLIST script                com_class           CDATA #IMPLIED>     <!-- Fr eine COM-Klasse -->\n"
"<!ATTLIST script                filename            CDATA #IMPLIED>     <!-- Falls die COM-Klasse in einer bestimmten DLL liegt -->\n"
"<!ATTLIST script                java_class          CDATA #IMPLIED>     <!-- Fr eine Java-Klasse -->\n"
"<!ATTLIST script                recompile           CDATA #IMPLIED>     <!-- 'yes': immer bersetzen. 'no': Nur bersetzen, wenn Quelle neuer -->\n"
"<!ATTLIST script                process_class       CDATA #IMPLIED>     <!--  -->\n"
"\n"
"\n"
"\n"
"<!ELEMENT include               EMPTY>\n"
"<!ATTLIST include               file                CDATA #REQUIRED>\n"
"\n"
"\n"
"<!ELEMENT job_chains            ( job_chain+ )>\n"
"\n"
"<!ELEMENT job_chain             ( job_chain_node+ )>\n"
"<!ATTLIST job_chain             name                CDATA #REQUIRED>\n"
"<!ATTLIST job_chain             visible             (yes|no) #IMPLIED>\n"
"\n"
"<!ELEMENT job_chain_node        EMPTY>\n"
"<!ATTLIST job_chain_node        state               CDATA #REQUIRED>\n"
"<!ATTLIST job_chain_node        job                 CDATA #IMPLIED>\n"
"<!ATTLIST job_chain_node        next_state          CDATA #IMPLIED>\n"
"<!ATTLIST job_chain_node        error_state         CDATA #IMPLIED>\n"
"\n"
"<!ELEMENT jobs                  ( job+ )>\n"
"\n"
"<!ELEMENT job                   ( description?, params?, ( object_set | script | process )?, monitor?, start_when_directory_changed*, delay_after_error*, delay_order_after_setback*, run_time? )>\n"
"<!ATTLIST job                   name                CDATA #REQUIRED>    <!-- ber alle Threads eindeutiger Name -->\n"
"<!ATTLIST job                   visible             (yes|no) #IMPLIED>\n"
"<!ATTLIST job                   priority            CDATA #IMPLIED>          <!-- Hhere Zahl ist hhere Prioritt -->\n"
"<!ATTLIST job                   temporary           (yes|no) 'no'>      <!-- Der Job wird nach einem Lauf entfernt -->\n"
"<!ATTLIST job                   output_level        CDATA #IMPLIED>     <!-- Stufennummer. Auf diese Stufe werden die Objekte der Objektemenge gesetzt -->\n"
"<!ATTLIST job                   spooler_id          CDATA #IMPLIED>     <!-- '': Job luft auf jedem Spooler, sonst nur Spooler mit derselben Spooler-Id -->\n"
"<!ATTLIST job                   title               CDATA #IMPLIED>     <!-- Bezeichnung des Jobs -->\n"
"<!ATTLIST job                   log_append          (yes|no) #IMPLIED>  <!-- Jobprotokoll fortschreiben, nicht berschreiben -->\n"
"<!ATTLIST job                   order               (yes|no) 'no'>      <!-- Job nimmt Auftrge an -->\n"
"<!ATTLIST job                   separate_process    (yes|no) 'no'>      <!-- Job-Instanzen (Tasks) sollen in getrennten, eigenen Prozessen laufen -->\n"
"<!ATTLIST job                   tasks               CDATA #IMPLIED>     <!-- Anzahl Tasks fr diesen Job -->\n"
"<!ATTLIST job                   timeout             CDATA #IMPLIED>     <!--  -->\n"
"<!ATTLIST job                   idle_timeout        CDATA #IMPLIED>     <!--  -->\n"
"<!ATTLIST job                   process_class       CDATA #IMPLIED>     <!--  -->\n"
"<!ATTLIST job                   mail_xslt_stylesheet CDATA #IMPLIED> \n"
"<!ATTLIST job                   java_options        CDATA #IMPLIED> \n"
"\n"
"\n"
"<!ELEMENT description           ( #PCDATA | include )*>                 <!-- Beschreibung des Jobs -->\n"
"\n"
"\n"
"<!ELEMENT object_set            ( levels? )>\n"
"<!ATTLIST object_set            class CDATA #REQUIRED>\n"
"\n"
"<!ELEMENT levels                EMPTY>          \n"
"<!ATTLIST levels                low                 CDATA #REQUIRED>    <!-- low <= level < high -->\n"
"<!ATTLIST levels                high                CDATA #REQUIRED>\n"
"\n"
"<!ELEMENT process               ( environment? )>\n"
"<!ATTLIST process               file                CDATA #REQUIRED>\n"
"<!ATTLIST process               param               CDATA #IMPLIED>\n"
"<!ATTLIST process               log_file            CDATA #IMPLIED>\n"
"<!ATTLIST process               ignore_error        CDATA #IMPLIED>\n"
"<!ATTLIST process               ignore_signal       CDATA #IMPLIED>\n"
"\n"
"<!ELEMENT environment           ( variable* )>\n"
"\n"
"<!ELEMENT variable              EMPTY>\n"
"<!ATTLIST variable              name                CDATA #REQUIRED>\n"
"<!ATTLIST variable              value               CDATA #REQUIRED>\n"
"\n"
"<!-- wenn der DLL-Aufruf implementiert ist:\n"
"<!ELEMENT module                EMPTY>\n"
"<!ATTLIST process               file                CDATA #REQUIRED>\n"
"-->\n"
"\n"
"<!ELEMENT monitor               ( script )>\n"
"\n"
"<!ELEMENT start_when_directory_changed     EMPTY>\n"
"<!ATTLIST start_when_directory_changed     directory      CDATA #REQUIRED>\n"
"<!ATTLIST start_when_directory_changed     regex          CDATA #IMPLIED>\n"
"\n"
"<!ELEMENT delay_after_error     EMPTY>\n"
"<!ATTLIST delay_after_error     error_count         CDATA #REQUIRED>\n"
"<!ATTLIST delay_after_error     delay               CDATA #REQUIRED>\n"
"\n"
"<!ELEMENT delay_order_after_setback EMPTY>\n"
"<!ATTLIST delay_order_after_setback setback_count   CDATA #REQUIRED>\n"
"<!ATTLIST delay_order_after_setback delay           CDATA #IMPLIED>\n"
"<!ATTLIST delay_order_after_setback is_maximum      (yes|no) #IMPLIED>\n"
"\n"
"<!ELEMENT run_time              ( period*, date*, weekdays?, monthdays?, ultimos?, ( holidays | holiday* ) )>\n"
"<!ATTLIST run_time              single_start        CDATA #IMPLIED>     <!-- Statt begin: Task wird nur einmal um diese Zeit gestartet --> \n"
"<!ATTLIST run_time              begin               CDATA #IMPLIED>     <!-- HH:MM:SS, Tageszeit, ab der der Job laufen soll -->\n"
"<!ATTLIST run_time              end                 CDATA #IMPLIED>     <!-- HH:MM:SS, Tageszeit, bis zu der der Job laufen soll -->\n"
"<!ATTLIST run_time              let_run             (yes|no) #IMPLIED>  <!-- Task zuende laufen lassen, auch wenn Endezeit berschritten ist -->\n"
"<!ATTLIST run_time              repeat              CDATA #IMPLIED>     <!-- Periode, nach der ein Job erneut gestartet wird, \n"
"                                                                             um zu prfen, ob die Objektemenge nicht leer ist -->\n"
"<!ATTLIST run_time              once                (yes|no) #IMPLIED>  <!-- Job trotz repeat='' bei Spooler-Start, Reload oder Reread einmal starten -->\n"
"\n"
"<!ELEMENT period                EMPTY>\n"
"<!ATTLIST period                single_start        CDATA    #IMPLIED>  <!-- Ersetzt bergeordnetes single_start, begin und end  --> \n"
"<!ATTLIST period                begin               CDATA    #IMPLIED>  <!-- Ersetzt bergeordnetes single_start, begin und end  --> \n"
"<!ATTLIST period                end                 CDATA    #IMPLIED>  <!-- Ersetzt bergeordnetes single_start, begin und end  --> \n"
"<!ATTLIST period                let_run             (yes|no) #IMPLIED>  <!-- Ersetzt bergeordnetes let_run  --> \n"
"<!ATTLIST period                repeat              CDATA    #IMPLIED>  <!-- Ersetzt bergeordnetes repeat  --> \n"
"\n"
"<!ELEMENT date                  ( period* )>                            <!-- Ein bestimmter Tag, an dem der Job laufen soll -->\n"
"<!ATTLIST date                  date                CDATA #IMPLIED>     <!-- yyyy-mm-dd -->\n"
"\n"
"<!ELEMENT weekdays              ( day+ )>                               <!-- 0: Sonntag, 6: Sonnabend -->\n"
"\n"
"<!ELEMENT monthdays             ( day+ )>                               <!-- 1 bis 31 -->\n"
"\n"
"<!ELEMENT ultimos               ( day+ )>                               <!-- 0 bis 30 Tage vor Ultimo -->\n"
"\n"
"<!ELEMENT holidays              ( holiday* )>                              \n"
"\n"
"<!ELEMENT holiday               EMPTY>                              \n"
"<!ATTLIST holiday               date                CDATA #REQUIRED>    <!-- yyyy-mm-dd, an diesem Tag den Job nicht starten -->\n"
"\n"
"<!ELEMENT day                   ( period* )>\n"
"<!ATTLIST day                   day                 CDATA #REQUIRED>\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"<!-- KOMMANDOS  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -->\n"
"\n"
"<!ELEMENT command               ( %command; )+ >\n"
"\n"
"\n"
"<!ELEMENT add_jobs              ( job+ )>\n"
"                                                                                   <!-- Antwort: <ok> -->\n"
"\n"
"\n"
"<!ELEMENT add_order             ( params?, run_time? )>\n"
"<!ATTLIST add_order             job_chain           CDATA #REQUIRED>\n"
"<!ATTLIST add_order             id                  CDATA #IMPLIED>\n"
"<!ATTLIST add_order             priority            CDATA #IMPLIED>\n"
"<!ATTLIST add_order             title               CDATA #IMPLIED>\n"
"<!ATTLIST add_order             state               CDATA #IMPLIED>\n"
"<!ATTLIST add_order             job                 CDATA #IMPLIED>\n"
"<!ATTLIST add_order             web_service         CDATA #IMPLIED>\n"
"                                                                                   <!-- Antwort: <ok> -->\n"
"\n"
"\n"
"<!ELEMENT modify_job            ( run_time? ) >\n"
"<!ATTLIST modify_job            job                 CDATA #REQUIRED>\n"
"<!ATTLIST modify_job            cmd                 ( stop\n"
"                                                    | unstop\n"
"                                                    | start\n"
"                                                    | wake\n"
"                                                    | end\n"
"                                                    | suspend\n"
"                                                    | continue\n"
"                                                    | reread\n"
"                                                    | remove       ) #IMPLIED>\n"
"                                                                                   <!-- Antwort: <ok> -->\n"
"\n"
"\n"
"<!ELEMENT modify_spooler        EMPTY>\n"
"<!ATTLIST modify_spooler        cmd                 ( pause\n"
"                                                    | continue\n"
"                                                    | stop\n"
"                                                    | reload\n"
"                                                    | terminate\n"
"                                                    | terminate_and_restart\n"
"                                                    | let_run_terminate_and_restart\n"
"                                                    | abort_immediately             \n"
"                                                    | abort_immediately_and_restart ) #IMPLIED>\n"
"                                                                                   <!-- Antwort: <ok> -->\n"
"<!ATTLIST modify_spooler        timeout             CDATA #IMPLIED>\n"
"\n"
"\n"
"<!ELEMENT show_history          EMPTY>\n"
"<!ATTLIST show_history          job                 CDATA #REQUIRED>\n"
"<!ATTLIST show_history          id                  CDATA #IMPLIED>\n"
"<!ATTLIST show_history          prev                CDATA #IMPLIED>\n"
"<!ATTLIST show_history          next                CDATA #IMPLIED>\n"
"<!ATTLIST show_history          what                CDATA #IMPLIED>\n"                    
"<!ATTLIST show_history          max_orders          CDATA #IMPLIED>\n"                    
"\n"
"\n"
"<!ELEMENT show_job              EMPTY>\n"
"<!ATTLIST show_job              job                 CDATA #REQUIRED>\n"
"<!ATTLIST show_job              job_chain           CDATA #IMPLIED>\n"
"<!ATTLIST show_job              what                CDATA #IMPLIED>\n"                    
"<!ATTLIST show_job              max_orders          CDATA #IMPLIED>\n"                    
"<!ATTLIST show_job              max_task_history    CDATA #IMPLIED>\n"                    
"\n"
"\n"
"<!ELEMENT show_jobs             EMPTY>\n"
"<!ATTLIST show_jobs             what                CDATA #IMPLIED>\n"                    
"<!ATTLIST show_jobs             max_orders          CDATA #IMPLIED>\n"                    
"<!ATTLIST show_jobs             max_task_history    CDATA #IMPLIED>\n"                    
"\n"
"\n"
"<!ELEMENT show_job_chains       EMPTY>\n"
"<!ATTLIST show_job_chains       what                CDATA #IMPLIED>\n"                    
"<!ATTLIST show_job_chains       max_orders          CDATA #IMPLIED>\n"                    
"\n"
"\n"
"<!ELEMENT show_job_chain        EMPTY>\n"
"<!ATTLIST show_job_chain        job_chain           CDATA #REQUIRED>\n"                    
"<!ATTLIST show_job_chain        what                CDATA #IMPLIED>\n"                    
"<!ATTLIST show_job_chain        max_orders          CDATA #IMPLIED>\n"                    
"\n"
"\n"
"<!ELEMENT show_order            EMPTY>\n"
"<!ATTLIST show_order            job_chain           CDATA #REQUIRED>\n"
"<!ATTLIST show_order            order               CDATA #REQUIRED>\n"
"<!ATTLIST show_order            what                CDATA #IMPLIED>\n"                    
"\n"
"\n"
"<!ELEMENT s                     EMPTY>                                             <!-- wie show_state -->\n"
"<!ATTLIST s                     what                CDATA #IMPLIED>\n"                    
"<!ATTLIST s                     max_orders          CDATA #IMPLIED>\n"                    
"<!ATTLIST s                     max_task_history    CDATA #IMPLIED>\n"                    
"\n"
"<!ELEMENT show_state            EMPTY>                                             <!-- Liefert den Zustand des Spoolers -->\n"
"<!ATTLIST show_state            what                CDATA #IMPLIED>\n"                    
"<!ATTLIST show_state            max_orders          CDATA #IMPLIED>\n"                    
"<!ATTLIST show_state            max_task_history    CDATA #IMPLIED>\n"                    
"                                                                                   <!-- Antwort: <state> -->\n"
"\n"
"\n"
"<!ELEMENT show_task             EMPTY>\n"
"<!ATTLIST show_task             id                  CDATA #REQUIRED>\n"
"<!ATTLIST show_task             what                CDATA #IMPLIED>\n"                    
"\n"
"                                                                                   <!-- Antwort: <state> -->\n"
"\n"
"\n"
"<!ELEMENT kill_task             EMPTY>\n"
"<!ATTLIST kill_task             job                 CDATA #REQUIRED>\n"
"<!ATTLIST kill_task             id                  CDATA #REQUIRED>\n"
"<!ATTLIST kill_task             immediately         ( yes | no )  #IMPLIED>\n"
"\n"
"\n"
"<!ELEMENT start_job             ( params? )>\n"
"<!ATTLIST start_job             job                 CDATA #REQUIRED>\n"
"<!ATTLIST start_job             name                CDATA #IMPLIED>     <!-- Name der Task -->\n"
"<!ATTLIST start_job             at                  CDATA #IMPLIED>     <!-- Startzeitpunkt, auch 'now' und 'today 17:00' -->\n"
"<!ATTLIST start_job             after               CDATA #IMPLIED>     <!-- oder Start nach soviel Sekunden -->\n"
"<!ATTLIST start_job             web_service         CDATA #IMPLIED>\n"
                                                                        "<!-- Antwort: <ok> -->\n"
"\n"
"\n"
"<!ELEMENT terminate             EMPTY>\n"
"\n"
"\n"
"<!ELEMENT params                ( param* )>                             <!-- Parameter fr cmd='start' -->\n"
"\n"
"<!ELEMENT param                 EMPTY>\n"
"<!ATTLIST param                 name                CDATA #REQUIRED>    <!-- Name des Parameters -->\n"
"<!ATTLIST param                 value               CDATA #REQUIRED>    <!-- Wert des Parameters -->\n"
"\n"
"\n"
"\n"
"<!ELEMENT signal_object         EMPTY>                                  <!-- Gibt Spooler Bescheid, dass ein neues Objekt da ist -->\n"
"<!ATTLIST signal_object         class               CDATA #REQUIRED>    <!-- Objektemengeklasse des Objekts -->\n"
"<!ATTLIST signal_object         level               CDATA #REQUIRED>    <!-- Stufennummer -->\n"
"                                                                        <!-- Antwort: <tasks> -->\n"
"\n"
"\n"
"\n"
"<!ELEMENT register_remote_scheduler  ( ERROR? ) >\n"
"<!ATTLIST register_remote_scheduler  version        CDATA #IMPLIED>\n"
"<!ATTLIST register_remote_scheduler  scheduler_id   CDATA #IMPLIED>\n"
"<!ATTLIST register_remote_scheduler  tcp_port       CDATA #IMPLIED>\n"
"<!ATTLIST register_remote_scheduler  logoff         ( yes | no )  #IMPLIED>\n"
"                                                                        <!-- Antwort: <ok> -->\n"
"\n"
"\n"
"\n"
"<!ELEMENT modify_order         EMPTY >\n"
"<!ATTLIST modify_order         job_chain            CDATA #REQUIRED >\n"
"<!ATTLIST modify_order         order                CDATA #REQUIRED >\n"
"<!ATTLIST modify_order         priority             CDATA #IMPLIED >\n"
"\n"
"\n"
"\n"
"<!ELEMENT remove_order         EMPTY >\n"
"<!ATTLIST remove_order         job_chain            CDATA #REQUIRED >\n"
"<!ATTLIST remove_order         order                CDATA #REQUIRED >\n"
"\n"
"\n"
"\n"
"<!ELEMENT remove_job_chain     EMPTY >\n"
"<!ATTLIST remove_job_chain     job_chain            CDATA #REQUIRED >\n"
"\n"
"\n"
"\n"
"\n"
"<!ELEMENT web_services         ( web_service* ) >\n"

"<!ELEMENT web_service          EMPTY >\n"
"<!ATTLIST web_service          name                        CDATA #REQUIRED >\n"
"<!ATTLIST web_service          url_path                    CDATA #REQUIRED >\n"
"<!ATTLIST web_service          request_xslt_stylesheet     CDATA #REQUIRED >\n"
"<!ATTLIST web_service          response_xslt_stylesheet    CDATA #REQUIRED >\n"
"<!ATTLIST web_service          forward_xslt_stylesheet     CDATA #IMPLIED  >\n"
"<!ATTLIST web_service          debug                       (yes|no) #IMPLIED >\n"
"\n"
"\n"
"\n"
"\n"
"<!ELEMENT service_request      ( web_service?, content ) >\n"
"<!ATTLIST service_request      url                         CDATA #IMPLIED>\n"
"<!ATTLIST service_request      url_path                    CDATA #IMPLIED>\n"
"\n"
"\n"
"\n"
"<!ELEMENT content              ( #PCDATA ) >\n"
"\n"
"\n"
"\n"
/*
"<!-- ANTWORTEN AUF DIE KOMMANDOS  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -->\n"
"<!-- veraltet -->\n"
"\n"
"<!ELEMENT answer                ( state | task | ERROR )>\n"
"\n"
"<!ELEMENT state                 ( tasks )>\n"
"<!ATTLIST state                 time                CDATA #REQUIRED>    <!-- yyyy-mm-dd HH:MM:SS -->\n"
"<!ATTLIST state                 running_since       CDATA #IMPLIED>     <!-- yyyy-mm-dd HH:MM:SS -->\n"
"<!ATTLIST state                 log_file            CDATA #IMPLIED>\n"
"<!ATTLIST state                 sleeping_until      CDATA #IMPLIED>     <!-- yyyy-mm-dd HH:MM:SS -->\n"
"<!ATTLIST state                 tasks               CDATA #IMPLIED>     <!-- Zahl seit Spooler-Start gestarteter Tasks -->\n"
"<!ATTLIST state                 steps               CDATA #IMPLIED>     <!-- Zahl seit Spooler-Start erfolgreich ausgefhrter Schritte -->\n"
"<!ATTLIST state                 cpu_time            CDATA #IMPLIED>     <!-- 9.999 -->\n"
"\n"
"<!ELEMENT tasks                 ( task+ )>\n"
"\n"
"<!ELEMENT task                  ( description?, queued_tasks?, ERROR? )>\n"
"<!ATTLIST task                  job                 CDATA #REQUIRED>    <!-- Jobname -->\n"
"<!ATTLIST task                  title               CDATA #IMPLIED>\n"
"<!ATTLIST task                  state               (stopped|pending|running|suspended) #REQUIRED>\n"
"                                                                        <!-- state='stopped'  : Keine Task wird mehr gestartet -->\n"
"                                                                        <!-- state='pending'  : Task wartet auf nchsten  -->\n"
"                                                                        <!-- state='running'  : Task luft -->\n"
"                                                                        <!-- state='suspended': Task vorbergehend angehalten -->\n"
"<!ATTLIST task                  calling             CDATA #IMPLIED>     <!-- Aktive Routine des Skripts -->\n"
"<!ATTLIST task                  steps               CDATA #IMPLIED>     <!-- Anzahl der bisher ausgefhrten Jobschritte -->\n"
"<!ATTLIST task                  running_since       CDATA #IMPLIED>     <!-- yyyy-mm-dd HH:MM:SS -->\n"
"<!ATTLIST task                  next_start_time     CDATA #IMPLIED>     <!-- yyyy-mm-dd HH:MM:SS -->\n"
"\n"
"<!ELEMENT queued_tasks          ( queued_task* )>\n"
"\n"
"<!ELEMENT queued_task           EMPTY>\n"
"<!ATTLIST queued_task           enqueued            CDATA #REQUIRED>    <!-- yyyy-mm-dd HH:MM:SS -->\n"
"<!ATTLIST queued_task           name                CDATA #IMPLIED>     <!-- Wert der Variablen spooler_task_name -->\n"
"\n"
"\n"
"<!ELEMENT ok                    EMPTY>\n"
"\n"
"<!ELEMENT ERROR                 EMPTY>\n"
"<!ATTLIST ERROR                 time                CDATA #REQUIRED>    <!-- yyyy-mm-dd HH:MM:SS -->\n"
"<!ATTLIST ERROR                 class               CDATA #IMPLIED>     <!-- 'EOF' -->\n"
"<!ATTLIST ERROR                 code                CDATA #REQUIRED>    <!-- 'SOS-1234' -->\n"
"<!ATTLIST ERROR                 text                CDATA #REQUIRED>    <!-- Fehlertext mit Fehlercode -->\n"
"<!ATTLIST ERROR                 source              CDATA #IMPLIED>     <!-- Dateiname -->\n"
"<!ATTLIST ERROR                 line                CDATA #IMPLIED>     <!-- Zeilennummer, beginned mit 1 -->\n"
"<!ATTLIST ERROR                 col                 CDATA #IMPLIED>     <!-- Spaltennummer, beginned mit 1 -->\n"
*/
;

//-------------------------------------------------------------------------------------------------

} //namespace spooler
} //namespace sos
